// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{prelude::*, translate::*};
use std::fmt;

glib::wrapper! {
    #[doc(alias = "DzlMenuManager")]
    pub struct MenuManager(Object<ffi::DzlMenuManager, ffi::DzlMenuManagerClass>);

    match fn {
        type_ => || ffi::dzl_menu_manager_get_type(),
    }
}

impl MenuManager {
    #[doc(alias = "dzl_menu_manager_new")]
    pub fn new() -> MenuManager {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::dzl_menu_manager_new()) }
    }

    #[doc(alias = "dzl_menu_manager_get_menu_by_id")]
    #[doc(alias = "get_menu_by_id")]
    pub fn menu_by_id(&self, menu_id: &str) -> Option<gio::Menu> {
        unsafe {
            from_glib_none(ffi::dzl_menu_manager_get_menu_by_id(
                self.to_glib_none().0,
                menu_id.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_menu_manager_merge")]
    pub fn merge(&self, menu_id: &str, model: &impl IsA<gio::MenuModel>) -> u32 {
        unsafe {
            ffi::dzl_menu_manager_merge(
                self.to_glib_none().0,
                menu_id.to_glib_none().0,
                model.as_ref().to_glib_none().0,
            )
        }
    }

    #[doc(alias = "dzl_menu_manager_remove")]
    pub fn remove(&self, merge_id: u32) {
        unsafe {
            ffi::dzl_menu_manager_remove(self.to_glib_none().0, merge_id);
        }
    }
}

#[cfg(feature = "v3_26")]
#[cfg_attr(docsrs, doc(cfg(feature = "v3_26")))]
impl Default for MenuManager {
    fn default() -> Self {
        Self::new()
    }
}

impl fmt::Display for MenuManager {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("MenuManager")
    }
}
